// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// GroupCallStreams represents TL type `groupCallStreams#c89191b`.
type GroupCallStreams struct {
	// A list of group call streams
	Streams []GroupCallStream
}

// GroupCallStreamsTypeID is TL type id of GroupCallStreams.
const GroupCallStreamsTypeID = 0xc89191b

// Ensuring interfaces in compile-time for GroupCallStreams.
var (
	_ bin.Encoder     = &GroupCallStreams{}
	_ bin.Decoder     = &GroupCallStreams{}
	_ bin.BareEncoder = &GroupCallStreams{}
	_ bin.BareDecoder = &GroupCallStreams{}
)

func (g *GroupCallStreams) Zero() bool {
	if g == nil {
		return true
	}
	if !(g.Streams == nil) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (g *GroupCallStreams) String() string {
	if g == nil {
		return "GroupCallStreams(nil)"
	}
	type Alias GroupCallStreams
	return fmt.Sprintf("GroupCallStreams%+v", Alias(*g))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*GroupCallStreams) TypeID() uint32 {
	return GroupCallStreamsTypeID
}

// TypeName returns name of type in TL schema.
func (*GroupCallStreams) TypeName() string {
	return "groupCallStreams"
}

// TypeInfo returns info about TL type.
func (g *GroupCallStreams) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "groupCallStreams",
		ID:   GroupCallStreamsTypeID,
	}
	if g == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Streams",
			SchemaName: "streams",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (g *GroupCallStreams) Encode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode groupCallStreams#c89191b as nil")
	}
	b.PutID(GroupCallStreamsTypeID)
	return g.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (g *GroupCallStreams) EncodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't encode groupCallStreams#c89191b as nil")
	}
	b.PutInt(len(g.Streams))
	for idx, v := range g.Streams {
		if err := v.EncodeBare(b); err != nil {
			return fmt.Errorf("unable to encode bare groupCallStreams#c89191b: field streams element with index %d: %w", idx, err)
		}
	}
	return nil
}

// Decode implements bin.Decoder.
func (g *GroupCallStreams) Decode(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode groupCallStreams#c89191b to nil")
	}
	if err := b.ConsumeID(GroupCallStreamsTypeID); err != nil {
		return fmt.Errorf("unable to decode groupCallStreams#c89191b: %w", err)
	}
	return g.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (g *GroupCallStreams) DecodeBare(b *bin.Buffer) error {
	if g == nil {
		return fmt.Errorf("can't decode groupCallStreams#c89191b to nil")
	}
	{
		headerLen, err := b.Int()
		if err != nil {
			return fmt.Errorf("unable to decode groupCallStreams#c89191b: field streams: %w", err)
		}

		if headerLen > 0 {
			g.Streams = make([]GroupCallStream, 0, headerLen%bin.PreallocateLimit)
		}
		for idx := 0; idx < headerLen; idx++ {
			var value GroupCallStream
			if err := value.DecodeBare(b); err != nil {
				return fmt.Errorf("unable to decode bare groupCallStreams#c89191b: field streams: %w", err)
			}
			g.Streams = append(g.Streams, value)
		}
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (g *GroupCallStreams) EncodeTDLibJSON(b tdjson.Encoder) error {
	if g == nil {
		return fmt.Errorf("can't encode groupCallStreams#c89191b as nil")
	}
	b.ObjStart()
	b.PutID("groupCallStreams")
	b.Comma()
	b.FieldStart("streams")
	b.ArrStart()
	for idx, v := range g.Streams {
		if err := v.EncodeTDLibJSON(b); err != nil {
			return fmt.Errorf("unable to encode groupCallStreams#c89191b: field streams element with index %d: %w", idx, err)
		}
		b.Comma()
	}
	b.StripComma()
	b.ArrEnd()
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (g *GroupCallStreams) DecodeTDLibJSON(b tdjson.Decoder) error {
	if g == nil {
		return fmt.Errorf("can't decode groupCallStreams#c89191b to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("groupCallStreams"); err != nil {
				return fmt.Errorf("unable to decode groupCallStreams#c89191b: %w", err)
			}
		case "streams":
			if err := b.Arr(func(b tdjson.Decoder) error {
				var value GroupCallStream
				if err := value.DecodeTDLibJSON(b); err != nil {
					return fmt.Errorf("unable to decode groupCallStreams#c89191b: field streams: %w", err)
				}
				g.Streams = append(g.Streams, value)
				return nil
			}); err != nil {
				return fmt.Errorf("unable to decode groupCallStreams#c89191b: field streams: %w", err)
			}
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetStreams returns value of Streams field.
func (g *GroupCallStreams) GetStreams() (value []GroupCallStream) {
	if g == nil {
		return
	}
	return g.Streams
}
