// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// ScopeNotificationSettings represents TL type `scopeNotificationSettings#ad8a189b`.
type ScopeNotificationSettings struct {
	// Time left before notifications will be unmuted, in seconds
	MuteFor int32
	// Identifier of the notification sound to be played; 0 if sound is disabled
	SoundID int64
	// True, if message content must be displayed in notifications
	ShowPreview bool
	// True, if notifications for incoming pinned messages will be created as for an ordinary
	// unread message
	DisablePinnedMessageNotifications bool
	// True, if notifications for messages with mentions will be created as for an ordinary
	// unread message
	DisableMentionNotifications bool
}

// ScopeNotificationSettingsTypeID is TL type id of ScopeNotificationSettings.
const ScopeNotificationSettingsTypeID = 0xad8a189b

// Ensuring interfaces in compile-time for ScopeNotificationSettings.
var (
	_ bin.Encoder     = &ScopeNotificationSettings{}
	_ bin.Decoder     = &ScopeNotificationSettings{}
	_ bin.BareEncoder = &ScopeNotificationSettings{}
	_ bin.BareDecoder = &ScopeNotificationSettings{}
)

func (s *ScopeNotificationSettings) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.MuteFor == 0) {
		return false
	}
	if !(s.SoundID == 0) {
		return false
	}
	if !(s.ShowPreview == false) {
		return false
	}
	if !(s.DisablePinnedMessageNotifications == false) {
		return false
	}
	if !(s.DisableMentionNotifications == false) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *ScopeNotificationSettings) String() string {
	if s == nil {
		return "ScopeNotificationSettings(nil)"
	}
	type Alias ScopeNotificationSettings
	return fmt.Sprintf("ScopeNotificationSettings%+v", Alias(*s))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*ScopeNotificationSettings) TypeID() uint32 {
	return ScopeNotificationSettingsTypeID
}

// TypeName returns name of type in TL schema.
func (*ScopeNotificationSettings) TypeName() string {
	return "scopeNotificationSettings"
}

// TypeInfo returns info about TL type.
func (s *ScopeNotificationSettings) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "scopeNotificationSettings",
		ID:   ScopeNotificationSettingsTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "MuteFor",
			SchemaName: "mute_for",
		},
		{
			Name:       "SoundID",
			SchemaName: "sound_id",
		},
		{
			Name:       "ShowPreview",
			SchemaName: "show_preview",
		},
		{
			Name:       "DisablePinnedMessageNotifications",
			SchemaName: "disable_pinned_message_notifications",
		},
		{
			Name:       "DisableMentionNotifications",
			SchemaName: "disable_mention_notifications",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *ScopeNotificationSettings) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode scopeNotificationSettings#ad8a189b as nil")
	}
	b.PutID(ScopeNotificationSettingsTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *ScopeNotificationSettings) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode scopeNotificationSettings#ad8a189b as nil")
	}
	b.PutInt32(s.MuteFor)
	b.PutLong(s.SoundID)
	b.PutBool(s.ShowPreview)
	b.PutBool(s.DisablePinnedMessageNotifications)
	b.PutBool(s.DisableMentionNotifications)
	return nil
}

// Decode implements bin.Decoder.
func (s *ScopeNotificationSettings) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode scopeNotificationSettings#ad8a189b to nil")
	}
	if err := b.ConsumeID(ScopeNotificationSettingsTypeID); err != nil {
		return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *ScopeNotificationSettings) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode scopeNotificationSettings#ad8a189b to nil")
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field mute_for: %w", err)
		}
		s.MuteFor = value
	}
	{
		value, err := b.Long()
		if err != nil {
			return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field sound_id: %w", err)
		}
		s.SoundID = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field show_preview: %w", err)
		}
		s.ShowPreview = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field disable_pinned_message_notifications: %w", err)
		}
		s.DisablePinnedMessageNotifications = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field disable_mention_notifications: %w", err)
		}
		s.DisableMentionNotifications = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (s *ScopeNotificationSettings) EncodeTDLibJSON(b tdjson.Encoder) error {
	if s == nil {
		return fmt.Errorf("can't encode scopeNotificationSettings#ad8a189b as nil")
	}
	b.ObjStart()
	b.PutID("scopeNotificationSettings")
	b.Comma()
	b.FieldStart("mute_for")
	b.PutInt32(s.MuteFor)
	b.Comma()
	b.FieldStart("sound_id")
	b.PutLong(s.SoundID)
	b.Comma()
	b.FieldStart("show_preview")
	b.PutBool(s.ShowPreview)
	b.Comma()
	b.FieldStart("disable_pinned_message_notifications")
	b.PutBool(s.DisablePinnedMessageNotifications)
	b.Comma()
	b.FieldStart("disable_mention_notifications")
	b.PutBool(s.DisableMentionNotifications)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (s *ScopeNotificationSettings) DecodeTDLibJSON(b tdjson.Decoder) error {
	if s == nil {
		return fmt.Errorf("can't decode scopeNotificationSettings#ad8a189b to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("scopeNotificationSettings"); err != nil {
				return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: %w", err)
			}
		case "mute_for":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field mute_for: %w", err)
			}
			s.MuteFor = value
		case "sound_id":
			value, err := b.Long()
			if err != nil {
				return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field sound_id: %w", err)
			}
			s.SoundID = value
		case "show_preview":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field show_preview: %w", err)
			}
			s.ShowPreview = value
		case "disable_pinned_message_notifications":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field disable_pinned_message_notifications: %w", err)
			}
			s.DisablePinnedMessageNotifications = value
		case "disable_mention_notifications":
			value, err := b.Bool()
			if err != nil {
				return fmt.Errorf("unable to decode scopeNotificationSettings#ad8a189b: field disable_mention_notifications: %w", err)
			}
			s.DisableMentionNotifications = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetMuteFor returns value of MuteFor field.
func (s *ScopeNotificationSettings) GetMuteFor() (value int32) {
	if s == nil {
		return
	}
	return s.MuteFor
}

// GetSoundID returns value of SoundID field.
func (s *ScopeNotificationSettings) GetSoundID() (value int64) {
	if s == nil {
		return
	}
	return s.SoundID
}

// GetShowPreview returns value of ShowPreview field.
func (s *ScopeNotificationSettings) GetShowPreview() (value bool) {
	if s == nil {
		return
	}
	return s.ShowPreview
}

// GetDisablePinnedMessageNotifications returns value of DisablePinnedMessageNotifications field.
func (s *ScopeNotificationSettings) GetDisablePinnedMessageNotifications() (value bool) {
	if s == nil {
		return
	}
	return s.DisablePinnedMessageNotifications
}

// GetDisableMentionNotifications returns value of DisableMentionNotifications field.
func (s *ScopeNotificationSettings) GetDisableMentionNotifications() (value bool) {
	if s == nil {
		return
	}
	return s.DisableMentionNotifications
}
